#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>

using namespace std;

int N;
vector<double> x;
vector<double> f;

int main(){

  cout << "Generate a plot of f(x) = sin(x) using N points." << endl;
  cout << " N = ";
  cin >> N;

  x.resize(N);
  f.resize(N);

  for(int i = 0; i < N; i++){
    //Generate a vector of points running between 0 and 2 pi
    x[i] = 0.0 + (double(i)/double(N-1))*2*M_PI;
    f[i] = sin(x[i]);
  }

  //Now that we've generated our data, we need to write it out to disk
  ofstream writer;
  writer.open("sinplot.dat");
  for(int i = 0; i < N; i++){
    writer << x[i] << " " << f[i] << endl;
  }
  writer.close();

  cout << "Data written to sinplot.dat. To plot, load in MATLAB/Excel/whatever you feel comfortable with." << endl;
  cout << "To plot using gnuplot, go to the directory that sinplot.dat is in, and type:" << endl;
  cout << "    >>gnuplot" << endl;
  cout << "    >>plot 'sinplot.dat' with linespoints" << endl;
  return 0;
}
